<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
    <title>Sensor Driver Configuration</title>

    <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

    <script src='../js/meti_merged.js'></script>
    <script src='../js/meti_utils.js'></script>

    <style>
        #main_body {
            visibility: hidden;
        }

        label {
            margin-bottom: 0px;
        }

        .custom-checkbox {
            min-height: 1rem;
        }

        .form-control,
        .form-select {
            margin-left: 2px;
            width: 100%;
        }

        .form-control-sm {
            padding: .2rem;
            font-size: .8rem;
        }

        /* height: calc(1.2em + .5rem + 2px); */
        /* font-size: .875rem;
            line-height: 1.5;
            border-radius: .2rem; */
        .custom-checkbox {
            /* margin-left: 2px; */
            min-height: 0.8rem;
        }

        /* #sensor_table {
            display: block;
            overflow-x: auto;
            white-space: nowrap;
        }

        #sensor_table_body {
            display: table;
            width: 100%;
        } */
        #header_div {
            font-size: 0.8rem;
        }

        #formID {
            visibility: hidden;
        }

        /* .header-itm {
            margin-left: 5px;
            color: brown;
            font-weight: bold;
        }

        .header-lbl {
            margin-left: 5px;
            color: blue;
            font-weight: bold;
        }

        .div_itm {
            padding: 5px;
        } */
        h6 {
            color: brown;
        }

        #header_div label {
            color: darkblue;
        }

        .arrow_up_class {
            border: 1px solid;
            background: bisque;
            cursor: pointer;
            margin-left: 2px;
        }

        .arrow_down_class {
            border: 1px solid;
            background: cornsilk;
            cursor: pointer;
        }

        .table-sm td,
        .table-sm th {
            padding: .15rem;
        }

        .delete_class {
            cursor: pointer;
        }
    </style>

</head>


<body>
    <div id="main_body">
        <div w3-include-html="meti_bst.html"></div>

        <div class="container">
            <div class="row" id="main_div">
                <main role="main">
                    <div class="row">
                        <h5>Sensor Driver Configuration</h5>
                        <div id="loader_driver" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
                        </div>
                    </div>
                    <form id="formID">
                        <div class="border border-primary p-2">
                            <!-- Header -->
                            <div id="header_div" class="row">
                                <!-- Serial_div -->
                                <div id="serial_div" class="col-sm-3">
                                    <h6>Serial Parameters</h6>
                                    <!-- Baud Rate -->
                                    <div id="baud_div" class="form-group p-0 m-1 row">
                                        <label class="col-sm-6" for="sel_baud">Baud Rate</label>
                                        <select class="col form-control form-control-sm" id="sel_baud" name="sel_baud"
                                            size="1">
                                            <option class="dropdown-item" value="0">115200</option>
                                            <option class="dropdown-item" value="1">57600</option>
                                            <option class="dropdown-item" value="2">38400</option>
                                            <option class="dropdown-item" value="3">19200</option>
                                            <option class="dropdown-item" value="4" selected>9600</option>
                                            <option class="dropdown-item" value="5">4800</option>
                                            <option class="dropdown-item" value="6">2400</option>
                                            <option class="dropdown-item" value="7">1200</option>
                                            <option class="dropdown-item" value="8">Disabled</option>
                                        </select>
                                    </div>

                                    <!-- Parity -->
                                    <div id="parity_div" class="form-group p-0 m-1 row">
                                        <label class="col-sm-6" for="sel_parity">Parity</label>
                                        <select class="col form-control form-control-sm" id="sel_parity"
                                            name="sel_parity" size="1">
                                            <option class="dropdown-item" value="0" selected>None</option>
                                            <option class="dropdown-item" value="1">Even</option>
                                            <option class="dropdown-item" value="2">Odd</option>
                                        </select>
                                    </div>

                                    <!-- Stop bits -->
                                    <!-- Narayan - check the values again -->
                                    <div class="form-group p-0 m-1 row">
                                        <label class="col-sm-6" for="sel_stopbits">Stop bits</label>
                                        <select class="col form-control form-control-sm" id="sel_stopbits"
                                            name="sel_stopbits" size="1">
                                            <option class="dropdown-item" value="1" selected>1 bit</option>
                                            <option class="dropdown-item" value="2">2 bits</option>
                                        </select>
                                    </div>
                                </div>

                                <!-- Command_div -->
                                <div id="command_div" class="col-sm-5">
                                    <h6>Modbus Command</h6>
                                    <!-- Slave/Device Id -->
                                    <div id="slaveId_div" class="form-group p-0 m-1 row">
                                        <label class="col-sm-5 header-lbl" for="sel_slaveId">Slave/ DeviceId</label>
                                        <select class="col  form-control form-control-sm header-itm" id="sel_slaveId"
                                            name="sel_slaveId" size="1">
                                        </select>
                                    </div>

                                    <!-- Function code -->
                                    <div class="form-group p-0 m-1 row">
                                        <label class="col-sm-5" for="sel_func">Function</label>
                                        <select class="col form-control form-control-sm" id="sel_func" name="sel_func"
                                            size="1">
                                            <option class="dropdown-item" value="1" selected>01 Coil Status (0x)
                                            </option>
                                            <option class="dropdown-item" value="2">02 Input Status (1x)</option>
                                            <option class="dropdown-item" value="3">03 Holding Register (4x)</option>
                                            <option class="dropdown-item" value="4">04 Input Register (3x)</option>
                                        </select>
                                    </div>

                                    <!-- Start register -->
                                    <div class="form-group p-0 m-1 row">
                                        <label class="col-sm-5" for="start_reg">Start Register</label>
                                        <input type="text" id="start_reg" name="start_reg"
                                            class="col form-control form-control-sm" autocomplete="off"
                                            data-validation-engine="validate[required], custom[integer], min[0], max[65535]">
                                    </div>

                                    <!-- Read Register Count -->
                                    <div class="form-group p-0 m-1 row">
                                        <label class="col-sm-5" for="sel_reg_count">Register Count</label>
                                        <select class="col form-control form-control-sm" id="sel_reg_count"
                                            name="sel_reg_count" size="1">
                                        </select>
                                    </div>
                                </div>

                                <!-- extra_div -->
                                <div id="extra_div" class="col">
                                    <h6>Other Params</h6>
                                    <!-- Read Timeout -->
                                    <div class="form-group p-0 m-1 row">
                                        <label class="col-sm-6" for="sel_timeout">Timeout (in mS)</label>
                                        <select class="col form-control form-control-sm" id="sel_timeout"
                                            name="sel_timeout" size="1">
                                        </select>
                                    </div>

                                    <!-- Retries -->
                                    <div id="retrives_div" class="form-group p-0 m-1 row">
                                        <label class="col-sm-6 header-lbl" for="sel_retries">Retries</label>
                                        <select class="col form-control form-control-sm header-itm" id="sel_retries"
                                            name="sel_retries" size="1">
                                        </select>
                                    </div>

                                    <!-- Read Interval -->
                                    <div id="read_interval_div" class="form-group p-0 m-1 row">
                                        <label class="col-sm-6 header-lbl" for="sel_read_interval">Interval (in
                                            secs)</label>
                                        <select class="col form-control form-control-sm header-itm"
                                            id="sel_read_interval" name="sel_read_interval" size="1">
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="border border-primary p-2">
                            <table id="sensor_table" class="table table-primary table-sm" style="width: 1100px;">
                                <thead class="sniffer_params" style="font-size:x-small">
                                    <tr>
                                        <th scope="col" style="width:4%">Sl</th>
                                        <th scope="col" style="width:2%">Mo ve</th>
                                        <th scope="col" style="width:7%">Reg Addr</th>
                                        <th scope="col" style="width:18%">Name</th>
                                        <th scope="col" style="width:8%">UOM</th>
                                        <th scope="col" style="width:12%">Data Type</th>
                                        <th scope="col" style="width:13%">Byte Order</th>
                                        <th scope="col" style="width:5%">Scaling Nume- rator</th>
                                        <th scope="col" style="width:5%">Scaling Denomi- nator</th>
                                        <th scope="col" style="width:5%">Offset</th>
                                        <th scope="col" style="width:5%">Decimals</th>
                                        <th scope="col" style="width:10%">Type</th>
                                        <th scope="col" style="width:8%; font-size:smaller">Active /
                                            Display /
                                            Transmit
                                        </th>
                                        <th scope="col" style="width:5%">Del</th>
                                    </tr>

                                </thead>
                                <tbody id="sensor_table_body">
                                    <!-- Sniffer data table comes here... -->
                                </tbody>
                            </table>
                            <button type="button" id="button_add"
                                class="btn btn-sm btn-info col-sm-1 m-1 nl_buttons">Add</button>
                        </div>
                        <div class="form-group row mt-1">
                            <button type="button" id="button_cancel"
                                class="btn btn-warning col ml-4 mr-4">Cancel</button>
                            <button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
                        </div>
                    </form>
                </main>
            </div>
        </div>
    </div>
</body>

<footer class="page-footer font-small blue pt-4">
    <div w3-include-html="footer.html"></div>
</footer>

</html>

<script>
    w3IncludeHTML();
    var myDataTypes = [{ "index": 0, "title": "bit0", "bytes": 1 }, { "index": 1, "title": "bit1", "bytes": 1 }, { "index": 2, "title": "bit2", "bytes": 1 }, { "index": 3, "title": "bit3", "bytes": 1 }, { "index": 4, "title": "bit4", "bytes": 1 }, { "index": 5, "title": "bit5", "bytes": 1 }, { "index": 6, "title": "bit6", "bytes": 1 }, { "index": 7, "title": "bit7", "bytes": 1 }, { "index": 8, "title": "uint8", "bytes": 2 }, { "index": 9, "title": "int16", "bytes": 2 }, { "index": 10, "title": "uint16", "bytes": 2 }, { "index": 11, "title": "int32", "bytes": 4 }, { "index": 12, "title": "uint32", "bytes": 4 }, { "index": 13, "title": "float", "bytes": 4 }, { "index": 14, "title": "stream_4_bytes", "bytes": 4 }, { "index": 15, "title": "int64", "bytes": 8 }, { "index": 16, "title": "uint64", "bytes": 8 }, { "index": 17, "title": "double", "bytes": 8 }, { "index": 18, "title": "ASCII", "bytes": 8 }]
    var myByteOrderIndex = [{ "order": "0123_3210", "bytes": 4 }, { "order": "0123_2301", "bytes": 4 }, { "order": "0123_0123", "bytes": 4 }, { "order": "0123_1032", "bytes": 4 }, { "order": "01_10", "bytes": 2 }, { "order": "01_01", "bytes": 2 }, { "order": "0_0", "bytes": 1 }, { "order": "1_0", "bytes": 1 }];
    var myReportGroupTypes = [{ "index": 1, "title": "Digital" }, { "index": 2, "title": "Analog" }, { "index": 3, "title": "Counter" }];

    $(document).ready(function () {
        $("#main_body").css("visibility", "visible");
        var sensor_list;
        $("#loader_driver").css("display", "block");

        setupSelects();

        function setupSelects() {
            // Baud rate options
            for (idx = 1; idx <= 255; idx++) {
                var opt = $('<option></option>')
                    .val(idx)
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(idx);

                $("#sel_slaveId").append(opt);
            }

            // Retries options
            for (idx = 0; idx <= 3; idx++) {
                var opt = $('<option></option>')
                    .val(idx)
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(idx);

                $("#sel_retries").append(opt);
            }

            //read interval options
            read_interval = [10, 15, 30, 60]
            for (idx = 0; idx < read_interval.length; idx++) {
                var opt = $('<option></option>')
                    .val(read_interval[idx])
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(read_interval[idx]);

                $("#sel_read_interval").append(opt);
            }

            // Read Register Count
            for (idx = 1; idx <= 62; idx++) {
                var opt = $('<option></option>')
                    .val(idx)
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(idx);

                $("#sel_reg_count").append(opt);
            }

            //read timeout options
            read_timeout = [100, 200, 300, 500, 1000, 2000, 3000]
            for (idx = 0; idx < read_timeout.length; idx++) {
                var opt = $('<option></option>')
                    .val(read_timeout[idx])
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(read_timeout[idx]);

                $("#sel_timeout").append(opt);
            }
        }
        // $("#formID").validationEngine('attach');

        $("#button_cancel").on("click", function () {
            document.location.href = "index.html";
        });

        $("#button_add").on("click", function () {
            last_idx = parseInt(edit_arr.length);
            if (edit_arr.length > 0) {
                if ($("#formID").validationEngine('validate')) {
                    edit_arr[last_idx] = JSON.parse(JSON.stringify(edit_arr[last_idx - 1]));

                    //add the bytes
                    var bytes = parseInt($('#dt_' + (last_idx - 1) + ' :selected').attr("data-bytes"));
                    if (bytes > 1) {
                        bytes = bytes / 2;
                    } else if (bytes == 1) {
                        bytes = 0;
                    }

                    edit_arr[last_idx].ra = parseInt(edit_arr[last_idx].ra) + bytes;
                    edit_arr[last_idx].nm = "";
                    edit_arr[last_idx].un = "";
                    updateTable();
                }
            }
        });

        $("#button_save").on("click", function () {
            var r = confirm("Save sensor configuration?");
            if (r == true) {
                save_drivers();
            }
        });

        var edit_arr = [];

        function displaySensors() {
            // addAdditionalPrams();
            sensor_list = g_modbus_drivers.command.responseParser;
            var ctr = 0;

            $("#sel_baud").val(g_modbus_drivers.serial.baud);
            $("#sel_parity").val(g_modbus_drivers.serial.parity);
            $("#sel_stopbits").val(g_modbus_drivers.serial.stopbits);

            $("#sel_slaveId").val(g_modbus_drivers.command.slaveId);
            $("#sel_func").val(g_modbus_drivers.command.function);
            $("#start_reg").val(g_modbus_drivers.command.startAddr);
            $("#sel_reg_count").val(g_modbus_drivers.command.regCount);

            $("#sel_timeout").val(g_modbus_drivers.command.timeOut);
            $("#sel_retries").val(g_modbus_drivers.command.retries);
            $("#sel_read_interval").val(g_modbus_drivers.command.repeat_int);

            edit_arr = [];
            ctr = 0;            
            $.each(g_modbus_drivers.command.responseParser, function (idx, val) {
                if (val.do == 1) {
                    val.do = ctr;
                }

                if (val.os == "0.000") {
                    val.os = "0";
                }
                edit_arr.push(JSON.parse(JSON.stringify(val)));
                ctr++;                
            });
            updateTable();
        }

        function updateTable() {
            // add cards to the deck from sensor list
            ctr = 0;
            $("#sensor_table_body").html("");

            $.each(edit_arr, function (idx, val) {
                var tr = $("<tr></tr>")
                    .addClass("w_table_row")
                    .attr("id", "row_" + ctr + 1)
                    .attr("data-idx", ctr);

                //Slno
                var slno_label = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm')
                    .attr('disabled', 'disabled')
                    .val(ctr + 1)


                var arrow_down = $('<label></label>')
                    .addClass("arrow_down_class")
                    .attr('data-idx', ctr)
                    .html('&#8595')

                var arrow_up = $('<label></label>')
                    .addClass("arrow_up_class")
                    .attr('data-idx', ctr)
                    .html('&#8593')

                //Start register address
                var ra_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm ')
                    .attr('id', 'ra_' + idx)
                    .css("color", "brown")
                    .val(val.ra)
                    .attr("data-validation-engine", "validate[required], custom[integer], min[0]")

                //Data type
                var dt_select = $("<select></select>")
                    .addClass("form-control form-control-sm class_dt")
                    .attr('id', 'dt_' + idx)
                    .css("color", "darkblue")

                $.each(myDataTypes, function (idx, val) {
                    // Only 4 byte data supported
                    if (val.bytes <= 4) {
                        var opt = $('<option></option>')
                            .val(val.index)
                            .addClass('dropdown-item dd-item')
                            .text(val.title)
                            .attr("data-bytes", val.bytes)

                        dt_select.append(opt);
                    }
                });
                dt_select.val(val.dt);

                bytes = myDataTypes[val.dt].bytes;

                //Byte order Index
                var bo_select = $("<select></select>")
                    .addClass("form-control form-control-sm ")
                    .attr('id', 'bo_' + idx)
                    .css("color", "blue")

                updateByteOrder(bo_select, bytes);
                bo_select.val(val.bo);

                //Scaling numerator
                var sn_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm')
                    .attr('id', 'sn_' + idx)
                    .val(val.sn)
                    .attr("maxLength", 10)
                    .attr("data-validation-engine", "validate[required], custom[number]")

                //Scaling denominator 
                var sd_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm ')
                    .attr('id', 'sd_' + idx)
                    .val(val.sd)
                    .attr("maxLength", 10)
                    .attr("data-validation-engine", "validate[required], custom[number]")

                //Sensor Offset
                var os_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm ')
                    .attr('id', 'os_' + idx)
                    .val(val.os)
                    .attr("maxLength", 10)
                    .attr("data-validation-engine", "validate[required], custom[number]")

                //decimal precision
                var dp_select = $('<select></select>')
                    .addClass('form-control form-control-sm ')
                    .attr('id', 'dp_' + idx)

                var dataArray = [0, 1, 2, 3, 4];
                for (idx1 = 0; idx1 < dataArray.length; idx1++) {
                    var opt = $('<option></option>')
                        .val(dataArray[idx1])
                        .addClass('dropdown-item')
                        .addClass('dd-item')
                        .text(dataArray[idx1]);
                    dp_select.append(opt);
                }
                dp_select.val(val.dp);

                //Sensor Name
                var nm_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm ')
                    .attr('id', 'nm_' + idx)
                    .css("color", "green")
                    .val(val.nm)
                    .attr("maxLength", 32)
                    .attr("data-validation-engine", "validate[required]")

                //Unit of measure
                var un_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('form-control form-control-sm ')
                    .attr('id', 'un_' + idx)
                    .attr("maxLength", 8)
                    .val(val.un)

                //Report Group
                var rg_select = $("<select></select>")
                    .addClass("form-control form-control-sm class_rg")
                    .attr('id', 'rg_' + idx)
                    .css("color", "darkblue")

                $.each(myReportGroupTypes, function (idx, val) {
                    var opt = $('<option></option>')
                        .val(val.index)
                        .addClass('dropdown-item dd-item')
                        .text(val.title)

                    rg_select.append(opt);
                });
                rg_select.val(val.rg);

                //Active
                var ac_input = $('<input></input>')
                    .attr('type', 'checkbox')
                    .addClass('col-3 custom-control custom-checkbox class_ac')
                    .attr('id', 'ac_' + idx)
                    .attr('checked', val.ac)

                //Display
                var di_input = $('<input></input>')
                    .attr('type', 'checkbox')
                    .addClass('col-3 custom-control custom-checkbox')
                    .attr('id', 'di_' + idx)
                    .attr('checked', val.di)

                //Transmit
                var tx_input = $('<input></input>')
                    .attr('type', 'checkbox')
                    .addClass('col-3 custom-control custom-checkbox')
                    .attr('id', 'tx_' + idx)
                    .attr('checked', val.tx)

                if (edit_arr.length > 1) {
                    var obj_del = $("<img>")
                        .addClass("delete_class")
                        .attr("src", '../images/delete.ico')
                        .attr("alt", "Delete")
                        .attr("data-idx", idx)
                        .attr("width", "24")
                        .attr("height", "24")
                        .attr("title", "Delete this row...")
                } else {
                    var obj_del = $("<div></div>");
                }

                var td_slno = $("<td scope='row'></td>")
                td_slno.append(slno_label);

                var td_arrows = $('<td style="display: inline-flex;"></td>');
                td_arrows.append(arrow_down);
                td_arrows.append(arrow_up);

                var td_ra = $('<td class="td_edit"></td>');
                td_ra.append(ra_input);

                var td_dt = $('<td class="td_edit"></td>');
                td_dt.append(dt_select);

                var td_bo = $('<td class="td_edit"></td>');
                td_bo.append(bo_select);

                var td_sn = $('<td class="td_edit"></td>');
                td_sn.append(sn_input);

                var td_sd = $('<td class="td_edit"></td>');
                td_sd.append(sd_input);

                var td_os = $('<td class="td_edit"></td>');
                td_os.append(os_input);

                var td_dp = $('<td class="td_edit"></td>');
                td_dp.append(dp_select);

                var td_nm = $('<td class="td_edit"></td>');
                td_nm.append(nm_input);

                var td_un = $('<td class="td_edit"></td>');
                td_un.append(un_input);

                var td_rg = $('<td class="td_edit"></td>');
                td_rg.append(rg_select);

                var td_ac = $('<td class="row td_edit" style="margin-left:0.05rem"></td>');
                td_ac.append(ac_input);
                td_ac.append(di_input);
                td_ac.append(tx_input);

                var td_del = $('<td></td>');
                td_del.append(obj_del);

                tr.append(td_slno);
                tr.append(td_arrows);
                tr.append(td_ra);
                tr.append(td_nm);
                tr.append(td_un);
                tr.append(td_dt);
                tr.append(td_bo);
                tr.append(td_sn);
                tr.append(td_sd);
                tr.append(td_os);
                tr.append(td_dp);
                tr.append(td_rg);
                tr.append(td_ac);
                tr.append(td_del);
                // tr.append(td_di);
                // tr.append(td_tx);

                $("#sensor_table_body").append(tr);

                // Just open the first sensor details....
                if (ctr == 0) {
                    $('#button_' + idx).click();
                }
                ctr++;
            });

            $(".class_dt").off("focus");
            $(".class_dt").on("focus", function () {
                var bytes = $("option:selected", this).attr("data-bytes");
                $(this).attr("data-prevBytes", bytes);
            })

            $(".class_dt").off("change");
            $(".class_dt").on("change", function () {
                // console.log($(this).val());
                var bytes = $("option:selected", this).attr("data-bytes");
                var prevBytes = $(this).attr("data-prevBytes");

                //if there is a change in number of bytes 
                //then update the byte order index
                if (bytes != prevBytes) {
                    updateByteOrder1($(this));
                }
                // val.bytes = myDataTypes[val.dt].bytes;
            })

            $(".class_ac").off("change");
            $(".class_ac").on("change", function () {
                var ac = $(this).is(":checked");
                var id = $(this).attr("id").substring(3);
                di_obj = $('#di_' + id);
                tx_obj = $('#tx_' + id);

                if (ac == false) {
                    di_obj.attr('disabled', 'disabled');
                    tx_obj.attr('disabled', 'disabled');
                } else {
                    di_obj.removeAttr('disabled');
                    tx_obj.removeAttr('disabled');
                }
            })

            $(".arrow_down_class").off("click");
            $(".arrow_down_class").on("click", function () {
                curr_idx = parseInt($(this).attr('data-idx'));
                if (curr_idx < edit_arr.length) {
                    next_idx = curr_idx + 1;

                    arraymove(edit_arr, curr_idx, next_idx);
                    updateTable();
                }
            });

            $(".arrow_up_class").off("click");
            $(".arrow_up_class").on("click", function () {
                curr_idx = parseInt($(this).attr('data-idx'));
                if (curr_idx > 0) {
                    prev_idx = curr_idx - 1;
                    arraymove(edit_arr, curr_idx, prev_idx);
                    updateTable();
                }
            });

            $(".td_edit").off("change");
            $(".td_edit").on("change", function () {
                if ($("#formID").validationEngine('validate')) {
                    var idx = $(this).closest('tr').attr("data-idx");
                    var val = edit_arr[idx];
                    val.ra = $('#ra_' + idx).val();
                    val.dt = $('#dt_' + idx + ' :selected').val();
                    val.bo = $('#bo_' + idx + ' :selected').val();
                    val.sn = $('#sn_' + idx).val();
                    val.sd = $('#sd_' + idx).val();
                    val.os = $('#os_' + idx).val();
                    val.dp = $('#dp_' + idx + ' :selected').val();
                    val.rg = $('#rg_' + idx + ' :selected').val();
                    val.nm = $('#nm_' + idx).val();
                    val.un = $('#un_' + idx).val();
                    val.ac = $('#ac_' + idx).is(":checked");
                    val.di = $('#di_' + idx).is(":checked");
                    val.tx = $('#tx_' + idx).is(":checked");
                }
            });

            $(".delete_class").off("click");
            $(".delete_class").on("click", function () {
                idx = $(this).attr("data-idx");
                //remove the row (exclude last row)
                if (edit_arr.length > 1) {
                    edit_arr.splice(idx, 1);
                    updateTable();
                }
            });

            $("#formID").css("visibility", "visible");

            $("#formID").validationEngine('detach');
            $("#formID").validationEngine('attach');
        }


        function arraymove(arr, fromIndex, toIndex) {
            var element = arr[fromIndex];
            arr.splice(fromIndex, 1);
            arr.splice(toIndex, 0, element);
        }

        function updateByteOrder1(obj) {
            var dt = obj.val();
            var id = obj.attr("id").substring(3);
            var bytes = $('#dt_' + id + ' :selected').attr("data-bytes");

            var bo_obj = $("#bo_" + id);
            updateByteOrder(bo_obj, bytes);
        }

        function updateByteOrder(bo_select, bytes) {
            bo_select.html('');
            $.each(myByteOrderIndex, function (idx, val) {
                if (val.bytes == bytes) {
                    var opt = $('<option></option>')
                        .val(idx)
                        .addClass('dropdown-item dd-item')
                        .text(val.order)
                    bo_select.append(opt);
                }
            });
        }

        function save_drivers() {
            var debug = 0;

            g_modbus_drivers.serial.baud = $("#sel_baud").val();
            g_modbus_drivers.serial.parity = $("#sel_parity").val();
            g_modbus_drivers.serial.stopbits = $("#sel_stopbits").val();

            g_modbus_drivers.command.slaveId = $("#sel_slaveId").val();
            g_modbus_drivers.command.function = $("#sel_func").val();
            g_modbus_drivers.command.startAddr = $("#start_reg").val();
            g_modbus_drivers.command.regCount = $("#sel_reg_count").val();

            g_modbus_drivers.command.timeOut = $("#sel_timeout").val();
            g_modbus_drivers.command.retries = $("#sel_retries").val();
            g_modbus_drivers.command.repeat_int = $("#sel_read_interval").val()

            //update sensor values
            g_modbus_drivers.command.responseParser = {};
            $.each(edit_arr, function (idx, val) {
                g_modbus_drivers.command.responseParser['sensor_' + idx] = val;
            });

            console.log(g_modbus_drivers);

            var driver_file = JSON.stringify(g_modbus_drivers);

            var data = {};
            data["driver_id"] = g_modbus_drivers.driver_id;

            MAX_POST_SIZE = 1000;
            var fileSize = driver_file.length;
            ctr = 0;
            while (fileSize > 0) {
                start = ctr * MAX_POST_SIZE;
                end = start + MAX_POST_SIZE;
                data["driver_file" + ctr] = driver_file.substring(start, end);
                fileSize = fileSize - MAX_POST_SIZE;
                ctr++;
            }
            data['driver_chunks'] = ctr;
            data['fileSize'] = driver_file.length;

            var url = "/saveNewModbusDriver";
            if (LOCAL_HOST == true) {
                url = "http://localhost/play/index.php/quickIoT/save_driver_to_device";
            }
            var type = 'POST';

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    if (debug == 1) {
                        console.log(response);
                    }
                    else {
                        // console.log(js_response);
                        var result = response.result;

                        if (result == 1) {
                            alert(response.message);
                        }
                        else if (result == 0) {
                            alert(response.message);
                        }
                    }
                },
                error: function (jqXHR, exception, response) {
                    alert('POST Error!');
                }
            });
        }

        function load_form_data() {
            //None
        }

        function getActiveDriver() {
            g_currentDriver = '';

            var url = "/getActiveModbusDriver";
            if (LOCAL_HOST == true) {
                var url = "http://localhost/modbus/drivers/mmd_3.json";
            }

            var type = 'POST';
            var data = {
                app_key: "quickIoT"
            };

            $("#loader_driver").css("display", "block");

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    $("#loader_driver").css("display", "none");
                    g_modbus_drivers = response;

                    if (typeof g_modbus_drivers.result === "undefined") {
                        // if proper driver response, list sensors
                        displaySensors();
                    } else {
                        // display error...
                        console.log(response.message);
                    }
                },
                error: function (jqXHR, exception, response) {
                    $("#loader_driver").css("display", "none");
                    alert('POST Error!! Unable to get selected driver...');
                }
            });
        }

        //********* Call all start up functions after this line *******//
        // updateConfigFromFS(load_form_data);
        // Narayan this has to be changed (dynamic driver id)
        // getLocalModbusDrivers(displaySensors);

        setTimeout(function () {
            getActiveDriver();
        }, 1500);
    });
</script>